#include "denise.h"
#include "denise_protos.h"

char select_option(struct DeniseHandle *handle, char *odp,char old_opis[20][100],char *opis,char poziom)
{
   struct WordEditor *wed;
   char option[20][100]; // 20 opcji po 100 znakw kada
   char ile_opcji=0,nr1;
   char temp[1000],*ptr;
   char pos=1;
   int k;

   // tworzymy list opcji
   for (wed=handle->language.wordeditor;wed!=NULL;wed=wed->next)
   {
      // jeli lista wed->data nie ma wymaganej liczby poziomw to pomijamy
      if (glo_count_parts(handle,wed->data,',')<poziom) continue;

      // sprawdzamy, czy poprzednie odpowiedzi byy zgodne z cigiem
      for (nr1=1;nr1<poziom;nr1++)
      {
         glo_get_part(wed->data,nr1,temp,',');
         if (strstr(temp,old_opis[nr1-1])==NULL) goto NEXT;
      }

      // skoro byy zgodne, to zapamitaj opcje
      glo_get_part(wed->data,poziom,temp,',');

      if (strncmp(temp,"(POS) ",6)==0)
      {
         memmove(temp,temp+6,strlen(temp)+1);
         pos=-1;
      }

      ptr=temp;
      for (;;)
      {
         if(strchr(ptr,'/')) k=strlen(strchr(ptr,'/'));
         else k=0;
         sprintf(option[atoi(ptr)-1],"%.*s",strlen(ptr)-k,ptr);
         ile_opcji=max(ile_opcji,atoi(ptr));

         ptr=strchr(ptr,'/');
         if (ptr==NULL) break;
         ptr=ptr+1;
      }
      NEXT: continue;
   }

   if (ile_opcji==0) return 0;

   for (nr1=0;nr1<ile_opcji;nr1++)
      printf("%s\n",option[nr1]);

   fflush(stdin);
   fgets(temp,1000,stdin);

   if (atoi(temp)<1 || atoi(temp)>ile_opcji) return -1;

   sprintf(opis,"%s",option[atoi(temp)-1]);
   *(odp+poziom-1)=(atoi(temp)+'A'-1)*pos; // ze znakiem "-" jeli to parametr pozycyjny

   return ile_opcji;
}

char pokaz_opis(struct DeniseHandle *handle, char *wyraz,char *opis,char *odmiany,char *result)
{
   /*
   funkcja wypisuje w formie tekstowej opis parametrw,
   - pobieramy numer z opisu,
   - kasujemy z posiadanych list te, ktre maj inny numer parametru,
     a w przeciwnym razie zapamitujemy parametr i kasujemy go z listy.
   - w przypadku, gdy podano wyraz:
     jeli powtrzono dla wszystkich parametrw, to obliczamy pozycj
     odmiany, i stosujemy do parametru pozycyjnego,
   - wypisujemy zapamitane parametry,

   funkcja zwraca liczb parametrw, ktre udao si rozpozna
   (ktre byy podane w opisie)
   */

   struct WordEditor *wed;
   char *data[1000],temp[1000],temp1[1000],poziom,nr2,ok,ile_param=0;
   int ile_list,nr1,pos;

   // akceptowanie parametrw: NULL i ""
   if (wyraz) if (strlen(wyraz)==0) wyraz=NULL;
   if (odmiany) if (strlen(odmiany)==0) odmiany=NULL;

   sprintf(result,"");

   ile_list=0;
   for (wed=handle->language.wordeditor;wed!=NULL;wed=wed->next,ile_list++) {
      data[ile_list]=wed->data;
   }
   data[ile_list]=NULL;

   for (poziom=0;poziom<strlen(opis);poziom++)
   {
      ok=0;
      for (nr1=0;nr1<ile_list;nr1++)
      {
         if(data[nr1]==NULL) continue;
	 else if(strlen(data[nr1])==0 || glo_count_parts(handle,data[nr1],',')<poziom+1) continue;
         glo_get_part(data[nr1],poziom+1,temp,',');
         // kontrola zgodnoci
         sprintf(temp1,"/%d-",opis[poziom]-'A'+1);
         if (atoi(temp)!=opis[poziom]-'A'+1 && strstr(temp,temp1)==NULL)
         {
            data[nr1]=NULL;
            continue;
         }

         if (ok==1) continue;
         ok=1;

         for (nr2=1;;nr2++)
         {
            glo_get_part(temp,nr2,temp1,'/');
            if (atoi(temp1)==opis[poziom]-'A'+1) break;
         }

         strcat(result,temp1);
         strcat(result,",");

         ile_param++;
      }
   }

   if (wyraz && odmiany && ile_param==strlen(opis))
   {
      for (pos=glo_get_part_position(1,odmiany,wyraz,',');pos!=0;pos=glo_get_part_position(pos+1,odmiany,wyraz,','))
      {
         for (nr1=0;nr1<ile_list;nr1++)
         {
	    if(data[nr1]==NULL) continue;
	    else if(strlen(data[nr1])==0 || glo_count_parts(handle,data[nr1],',')<poziom+1) continue;

            glo_get_part(data[nr1],poziom+1,temp,',');

            // musi to byparametr pozycyjny
            if (strncmp(temp,"(POS) ",6)!=0) continue;
            memmove(temp,temp+6,strlen(temp)+1);

            // kontrola zgodnoci
            sprintf(temp1,"/%d-",pos);
            if (atoi(temp)!=pos && strstr(temp,temp1)==NULL)
            {
               data[nr1]=NULL;
               continue;
            }

            for (nr2=1;;nr2++)
            {
               glo_get_part(temp,nr2,temp1,'/');
               if (atoi(temp1)==pos) break;
            }

            strcat(result,temp1);
            strcat(result,"/");

            break;
         }
      }
   }

   result[strlen(result)-1]='\0';

   return ile_param;
}

void wed_add_word(struct DeniseHandle *handle) 
{
   struct Fleksja *fleks;
   struct Odmiany *odm;
   char odp[20],poziom,nr1,nr2;
   char opis[20][100],ile_poz=1,poz=1;
   char podst[100],wyraz[100];
   char temp[1000];
   char inbuf[10];

   memset(odp,0,20);
   poziom=1;

   printf("\nwyraz: ");
   fflush(stdin);
   fgets(wyraz,100,stdin);
   if(strlen(wyraz)>0) wyraz[strlen(wyraz)-1]='\0';
   printf("podstawowy: ");
   fflush(stdin);
   fgets(podst,100,stdin);
   if(strlen(podst)>0) podst[strlen(podst)-1]='\0';
   //printf("podstawowy: %s\n",podst);

   if (strlen(podst)*strlen(wyraz)==0)
   {
      printf("operation canceled\n");
      return;
   }

   if ((fleks=voc_find_word(handle,handle->language.vocabulary,podst,"","",0))!=NULL)
   {
      printf("znaleziono domyslne opisy: (wybierz szablon)\n");
      for (nr1=0,odm=fleks->odm_head;odm!=NULL;odm=odm->next,nr1++)
      {
         printf("%d) -",nr1+1);
         pokaz_opis(handle,wyraz,odm->opis,odm->odmiany,temp);
         printf("%s\n",temp);
      }
      
      printf("ENTER - definiuj nowy opis\n");

      fflush(stdin);
      fgets(inbuf,10,stdin);
      nr2=inbuf[0]-'1'+1;
      if (nr2>=1 && nr2<=nr1)
      {
         for (nr1=0,odm=fleks->odm_head;nr1<nr2-1;odm=odm->next,nr1++);

         printf("ile parametrow wykorzystac (ENTER - wszystkie, 0 - cancel): ");
         fflush(stdin);
         fgets(inbuf,10,stdin);
         nr1=inbuf[0]-'1'+1;
         if (nr1<0) nr1=strlen(odm->opis);
         if (nr1>0)
         {
            nr1=min(nr1,pokaz_opis(handle,wyraz,odm->opis,odm->odmiany,temp));
            memcpy(odp,odm->opis,nr1);
            poziom=nr1+1;

            for (nr1=0;nr1<poziom-1;nr1++)
               glo_get_part(temp,nr1+1,opis[nr1],',');
         }
      }
   }

   for (;;poziom++)
   {
      if (odp[poziom-1]!=0) continue;

      nr1=select_option(handle,odp,opis,opis[poziom-1],poziom);
      if (nr1==0) break;
      else if (nr1==-1)
      {
         printf("operation canceled\n");
         return;
      }

      // jeli to parametr pozycyjny, to zapamitujemy liczb pozycji i pozycj
      if (odp[poziom-1]<0)
      {
         ile_poz=nr1;
         poz=-odp[poziom-1]-'A'+1;
      }
   }
   poziom--;

   for (nr1=0;nr1<poziom && odp[nr1]>0;nr1++)
      printf("%c",odp[nr1]);

   printf(" pozycja: %d/%d\n",poz,ile_poz);
   odp[nr1]='\0';

   // dodawanie wyrazu do bazy
   dodaj_wyraz(handle,&handle->language.vocabulary,wyraz,podst,odp,poz,ile_poz);
}

void wed_add_inflexion(struct DeniseHandle *handle) {
}
